package top.ninwoo.api;

import lombok.Data;

import java.io.Serializable;
import java.util.concurrent.ConcurrentHashMap;

/**
 * 路径计算数据包
 */
@Data
public class CnfData implements Serializable {
    //加入任务表：ConcurrentHashMap<卫星名字,功能函数名>
    private ConcurrentHashMap<String,String> taskTable = new ConcurrentHashMap<>();
    //加入路径表：String[]
    private String[] pathTable = new String[]{};
    //全局路由表：String[][]
    private String[][] route = new String[][]{};
    //IP池
    //sataName:sataIP
    private ConcurrentHashMap<String,String> IpPool = new ConcurrentHashMap<>();
    //加权路径路由表
    double[][] lt;

    //本机卫星名
    private String currentSataHop;
    //下一跳卫星名
    private String nextSataHop;
    //下一跳ip地址
    private String nextIPHop;
    //该条路径的目的卫星名
    private String destinSataHop;
    //图像
    private Picture picture;
    //终节点
    private String endSateHop;
    //源节点
    private String oriSateHop;
    //任务发起时刻
    private long time;
    //时隙大小
    private long gap = 20000;
    //卫星数目
    private int sataNum = 10;
    //阈值设定
    private double size;
}
