package top.ninwoo.cloud.controller;

import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.ui.Model;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.client.RestTemplate;
import org.springframework.web.multipart.MultipartFile;
import top.ninwoo.api.CnfData;
import top.ninwoo.api.Picture;
import top.ninwoo.cloud.service.cpcTrans.CpcTrans;
import top.ninwoo.cloud.service.dbctrans.DbcTrans;
import top.ninwoo.cloud.service.findService.FindServiceImpl;

import javax.annotation.Resource;
import javax.imageio.ImageIO;
import java.io.*;
import java.text.ParseException;
import java.util.Date;
import java.util.HashMap;
import java.util.LinkedList;
import java.util.concurrent.ConcurrentHashMap;

@Slf4j
@Controller
public class DataCtrl {

    @Autowired
    CpcTrans cpcTrans;

    @Autowired
    DbcTrans dbcTrans;

    private long starTime;


    @Resource
    private RestTemplate restTemplate;

    @RequestMapping(value = "/cpcTrans",method = RequestMethod.GET)
    public String Cpcupload() {
        return "cpcTrans";
    }

    @RequestMapping(value = "/cpcTrans")
    @ResponseBody
    public String CpcTrans(@RequestParam("file") MultipartFile file, @RequestParam("path_1") String path_1,@RequestParam("path_2") String path_2,@RequestParam("func") String fun) {
        if(!file.isEmpty()){
            try {
                //包装图片
                Picture picture = cpcTrans.packagePic(ImageIO.read(file.getInputStream()));
                //包装数据包
                //倘若数据不只是0-9之内，应用，隔开
                String[] path_1s = path_1.split(",");
                String[] path_2s = path_2.split(",");
                String[] funs = fun.split(",");
                //得到链路图
/*                int length = path_2.length();
                int func_length = fun.length();*/
                int[] func = new int[funs.length];
                int[][] link = new int[2][path_1s.length];

                for(int i=0; i<path_1s.length; i++) {
                    link[0][i] = Integer.parseInt(path_1s[i]);
                }
                for(int i=0; i<path_1s.length; i++) {
                    link[1][i] = Integer.parseInt(path_2s[i]);
                }

                for(int i=0; i<funs.length; i++) {
                    func[i] = Integer.parseInt(funs[i]);
                }

                System.out.println();
                log.info("//////////////////////////////////////////////");
                System.out.println();

                LinkedList<CnfData> cnfData = cpcTrans.packageData(picture,link,func);
                //发送
                Date time = new Date();
                starTime = time.getTime();
                System.out.println("开始路径计算： "+starTime);
                for (CnfData data : cnfData) {
                    cpcTrans.sendData(data, data.getNextIPHop());
                }

            } catch (IOException e) {
                e.printStackTrace();
                return "上传失败," + e.getMessage();
            } catch (ParseException e) {
                e.printStackTrace();
            }

            return "上传成功！";
        } else {
            return "上传失败，因为文件是空的.";
        }
    }

    @RequestMapping(value = "/dbcTrans",method = RequestMethod.GET)
    public String Dbcupload() {
        return "dbcTrans";
    }

    @PostMapping(value = "/dbcTrans")
    @ResponseBody
    public String DbcTrans(@RequestParam("file") MultipartFile file, @RequestParam("fileId") String fileId, @RequestParam("size") double size) {
        if(!file.isEmpty()){
            try {
                Date time = new Date();
                starTime = time.getTime();
                System.out.println("开始分散计算： " + starTime);
                //包装图片
                Picture picture = dbcTrans.packagePic(ImageIO.read(file.getInputStream()));
                //包装数据包
                LinkedList<CnfData> cnfData = dbcTrans.packageData(picture,"sate1");
                //发送
                for (CnfData data : cnfData) {
                    data.setTime(starTime);
                    data.setSize(size);
                    System.out.println(data.getGap());
                    dbcTrans.sendData(data, data.getNextIPHop());
                }
            } catch (FileNotFoundException e) {
                e.printStackTrace();
                return "上传失败," + e.getMessage();
            } catch (IOException e) {
                e.printStackTrace();
                return "上传失败," + e.getMessage();
            } catch (ParseException e) {
                e.printStackTrace();
            }
            return "上传成功！";
        } else {
            return "上传失败，因为文件是空的.";
        }
    }

    @RequestMapping(value = "/cpcDownload",method = RequestMethod.GET)
    public String Cpcdownload(Model model) {
        GetCpcImg();

        model.addAttribute("fileName", "cpc_images/sate11-0.jpg");

        return "cpcDownload";
    }


    @GetMapping(value = "/getcpcImg")
    @ResponseBody
    public String GetCpcImg(){
        FindServiceImpl findService = new FindServiceImpl();
        ConcurrentHashMap<String, String> ipool  = findService.findIPool();
        for (int i = 1; i < ipool.size()+1; i++) {
            String str = "sate"+i;
            System.out.println(str);
            String ip = ipool.get(str);
            System.out.println(ip);
            String path = "/var/www/html/cpc_images/";
            GetImg(str,ip,path);
        }
        return "sucess";
    }

    @GetMapping(value = "/getdbcImg")
    @ResponseBody
    public String GetDbcImg(){
        FindServiceImpl findService = new FindServiceImpl();
        ConcurrentHashMap<String, String> ipool  = findService.findIPool();
        for (int i = 1; i < ipool.size()+1; i++) {
            String str = "sate"+i;
            System.out.println(str);
            String ip = ipool.get(str);
            System.out.println(ip);
            String path = "/var/www/html/dbc_images/";
            GetImg(str,ip,path);
        }
        return "sucess";
    }

    public void GetImg(String sataname, String ip, String foldPath){
        String IP =ip + ":8083";
        byte[][] res = restTemplate.getForObject("http://" + IP +"/getImg",byte[][].class);
        if(res == null){
            System.out.println(sataname+"no picture");
            return;
        }
        //创建一个字节输出流
        OutputStream outputStream = null;
        try {
            int i = 0;
            for (byte[] re : res) {
                //得到新路径
                String path = foldPath+sataname+"-"+i+".jpg";
                outputStream = new FileOutputStream(path);
                //将图片输处到流中
                outputStream.write(re);
                //刷新
                outputStream.flush();
                i++;
            }

        } catch (IOException e) {
            e.printStackTrace();
        } finally {
            try {
                //关闭
                if (outputStream != null){
                    outputStream.close();
                }
            } catch (IOException e) {
                e.printStackTrace();
            }
        }
    }

    //获取计算能力
    @GetMapping("/getComputing")
    @ResponseBody
    public LinkedList<Double> getComputing() {
        FindServiceImpl findService = new FindServiceImpl();
        ConcurrentHashMap<String, String> ipool  = findService.findIPool();
        LinkedList<Double> cpuCom = new LinkedList<>();
        for (int i = 1; i < ipool.size(); i++) {
            String str = "sate"+i;
            String ip = ipool.get(str);
            double res = cpcTrans.sendCpuCtr(ip);
            cpuCom.add(res);
        }
        return cpuCom;
    }

    //卫星复位
    @GetMapping("/reset")
    @ResponseBody
    public String resetSate(){
        FindServiceImpl findService = new FindServiceImpl();
        ConcurrentHashMap<String, String> ipool  = findService.findIPool();
        for (int i = 1; i < ipool.size(); i++) {
            String str = "sate"+i;
            String ip = ipool.get(str);
            String res = dbcTrans.reset(ip);
            System.out.println(str+"复位："+res);
        }
        return "sucess";
    }

    //收到图片时的时间
    @PostMapping(value = "/getDate")
    @ResponseBody
    public String getDate(@RequestParam("message") String message) {
        System.out.println("返回收到信息：" + message);
        Date time = new Date();
        System.out.println("时间间隔：" + (time.getTime() - starTime)/1000 + "s");

        return "backEarth success";
    }

    //收到图片时的时间
    @PostMapping(value = "/getOverLoad")
    @ResponseBody
    public boolean getOverload(@RequestBody HashMap<String, String> param) {
        System.out.println("================================");
        System.out.println(param.get("sName")+" :"+param.get("overLoad"));
        System.out.println("================================");
        return true;
    }

    @GetMapping("/testCpc")
    @ResponseBody
    public String CpcTest() throws IOException {
        File file = new File("C:\\Users\\Elf\\Desktop\\test\\2.jpg");
        Picture picture = cpcTrans.packagePic(ImageIO.read(file));
        //包装数据包
        //LinkedList<CnfData> cnfData = cpcTrans.packageData(picture,null);
        //return cpcTrans.sendData(cnfData.get(0),cnfData.get(0).getNextIPHop());
        return null;
    }

    @GetMapping("/testDbc")
    @ResponseBody
    public CnfData DbcTest() throws IOException, ParseException {
        File file = new File("/home/elf/test3.jpg");
        Picture picture = dbcTrans.packagePic(ImageIO.read(file));
        LinkedList<CnfData> cnfData = dbcTrans.packageData(picture, "sate1");
        return cnfData.get(0);
    }

    @GetMapping("/test")
    @ResponseBody
    public CnfData Test1() throws IOException {
        File file = new File("C:\\Users\\Elf\\Desktop\\test\\1.jpg");
        Picture picture = cpcTrans.packagePic(ImageIO.read(file));
        //包装数据包
        //LinkedList<CnfData> cnfData = cpcTrans.packageData(picture);
        //String res = cpcTrans.sendData(cnfData.get(0),"127.0.0.1");
        //return cnfData.get(0);
        return null;
    }
    @GetMapping("/testlt")
    @ResponseBody
    public String[][] LtTest() throws IOException, ParseException {
        File file = new File("C:\\Users\\Elf\\Desktop\\test\\2.jpg");
        Picture picture = dbcTrans.packagePic(ImageIO.read(file));
        System.out.println(dbcTrans.getIt().length);
        return dbcTrans.getIt();
    }

    @GetMapping("/testDbc2")
    @ResponseBody
    public CnfData DbcTest2() throws IOException, ParseException {
        File file = new File("C:\\Users\\Elf\\Desktop\\test\\2.jpg");
        Picture picture = dbcTrans.packagePic(ImageIO.read(file));
        LinkedList<CnfData> cnfData = dbcTrans.packageData(picture, "sate1");
        return cnfData.get(0);
    }

}
