package top.ninwoo.cloud.service;

import java.util.ArrayList;
import java.util.concurrent.ConcurrentHashMap;

public interface FindService {
    /**
     * 根据路径表，找到本机需要处理路径条数
     * c->a ==>  sata1->sata3
     */
    ArrayList<String> findDestinSataHops(String[] pathTable, String currenthop);
    /**
     * 根据本机卫星名，全局路由表,路由表得到本机路由表
     */
    String[] findRoute(String currentSataHop, String[][] routeTable);
    /**
     * 得到ip池
     */
    ConcurrentHashMap<String,String> findIPool();
    /**
     * 根据目的卫星名，本机路由表找到下一跳卫星名
     */
    String findNextHop(String destinSataHop, String[] route);
    /**
     * 找到下一跳的ip地址
     * @return
     */
    String findIp(String sataName, ConcurrentHashMap<String,String> ipool);
}
