package top.ninwoo.cloud.service.csv;

import top.ninwoo.cloud.service.bpso.Bpso;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileInputStream;
import java.io.InputStreamReader;
import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.Date;

import static top.ninwoo.cloud.service.csv.GetTopo.TopoRequire;

public class Wteg {
    //获取当前3时隙拓扑
    /**
     * 先用SimpleDateFormat.parse() 方法将日期字符串转化为Date格式
     * 通过Date.getTime()方法，将其转化为毫秒数
     */
    public static double[][] getWteg(int dev) throws ParseException {
        //传输时间参数
        String str;
        String str1;
        String str2;

        //可在这里修改时间
        //todo 应该放在yaml文件中
        String dateInput = "5-00-00";
        long time;
        //测试时间
        str = ReadFile.date+" "+ dateInput;
        SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd HH-mm-ss");
        Date current1 = new Date(sdf.parse(str).getTime()+ (long) Bpso.slot);
        Date current2 = new Date(current1.getTime()+ (long)Bpso.slot);
        //网络信息表
        NodeL[][] parse = ReadFile.parse();
        //
        str1 = sdf.format(current1);
        str2 = sdf.format(current2);
        //产生三个时隙
        int[][] topo = TopoRequire(str,parse);
        int[][] topo1 = TopoRequire(str1,parse);
        int[][] topo2 = TopoRequire(str2,parse);

        //获得单时隙连接矩阵  0或MAXWEIGHT
        //等待下一时隙开始执行业务
        int num = Bpso.num;
        int MAXWEIGHT = Bpso.MAXWEIGHT;
        double slot = Bpso.slot;

        double[][] slot1 = new double[num][num];
        for(int i = 0;i<slot1.length;i++){
            for(int j = 0;j<slot1.length;j++){
                if (topo[i][j]==0){
                    if (i==j){
                        slot1[i][j]=0.0;
                    }else
                        slot1[i][j] = MAXWEIGHT;
                }else{
                    slot1[i][j] = 500;
                }

            }
        }
        double[][] slot2 = new double[num][num];
        for(int i = 0;i<slot2.length;i++){
            for(int j = 0;j<slot2.length;j++){
                if (topo1[i][j]==0){
                    if (i==j){
                        slot2[i][j]=0.0;
                    }else
                        slot2[i][j] = MAXWEIGHT;
                }else {
                    slot2[i][j] = 500;
                }
            }
        }
        double[][] slot3 = new double[num][num];
        for(int i = 0;i<slot3.length;i++){
            for(int j = 0;j<slot3.length;j++){
                if (topo2[i][j]==0){
                    if (i==j){
                        slot3[i][j]=0.0;
                    }else
                        slot3[i][j] = MAXWEIGHT;
                }else {
                    slot3[i][j] = 500;
                }
            }
        }
        //生成相邻时隙矩阵
        double[][] neighbor = new double[num][num];
        for(int i = 0;i<neighbor.length;i++){
            for(int j = 0;j<neighbor.length;j++){
                if(i == j){
                    neighbor[i][j] = slot;
                }else{
                    neighbor[i][j] = MAXWEIGHT;
                }
            }
        }
        //生成其余时隙矩阵
        double[][] nonNeighbor = new double[num][num];
        for(int i = 0;i<nonNeighbor.length;i++){
            for(int j = 0;j<nonNeighbor.length;j++){
                nonNeighbor[i][j] = MAXWEIGHT;
            }
        }
        //组装连接矩阵
        double[][] edgeWeight = new double[dev][dev];
        for(int i = 0;i<edgeWeight.length;i++){
            for(int j = 0;j<edgeWeight.length;j++){
                if (i>=0 & i<num & j>=0 & j<num) {
                    edgeWeight[i][j] = slot1[i][j];
                }else if (i>=num & i<2*num & j>=num & j<2*num) {
                    edgeWeight[i][j] = slot2[i%num][j%num];
                }else if (i>=2*num & i<3*num & j>=2*num & j<3*num) {
                    edgeWeight[i][j] = slot3[i%num][j%num];
                }else if ((i>=0 & i<num & j>=num & j<2*num) || (i>=num & i<2*num & j>=2*num & j<3*num)){
                    edgeWeight[i][j] = neighbor[i%num][j%num];
                }else {
                    edgeWeight[i][j] = nonNeighbor[i%num][j%num];
                }

            }
        }
        return edgeWeight;
    }

    public static double[][] getIridiumWteg(int dev){
        int maxweight = Bpso.MAXWEIGHT;
        int[][] result = readTxtFile("hjt1.txt",dev);
        double[][] resultD = new double[dev][dev];
        for (int i = 0;i<result.length;i++) {
            for (int j =0;j<result[0].length;j++) {
                if (i == j) {
                    resultD[i][j] = 0;
                }else if (result[i][j] == 1) {
                    resultD[i][j] = 500;
                }else {
                    resultD[i][j] = maxweight;
                }
            }
        }
        return resultD;
    }


    public static int[][] readTxtFile(String filePath,int dev){
        try {
            String encoding="GBK";
            File file=new File(filePath);
            if(file.isFile() && file.exists()){ //判断文件是否存在
                InputStreamReader read = new InputStreamReader(
                        new FileInputStream(file),encoding);//考虑到编码格式
                BufferedReader bufferedReader = new BufferedReader(read);
                String lineTxt = null;
                int[][] topo = new int[dev][dev];
                int index = 0;
                while((lineTxt = bufferedReader.readLine()) != null){
//                    System.out.println(lineTxt);
                    for (int i = 0;i<lineTxt.length();i++){
                        topo[index][i] = lineTxt.charAt(i)-'0';
                    }
                    index++;
//
                }
                read.close();
                return topo;
            }else{
                System.out.println("找不到指定的文件");
            }
        } catch (Exception e) {
            System.out.println("读取文件内容出错");
            e.printStackTrace();
        }

        return new int[0][];
    }
}

