package top.ninwoo.cloud.service.findService;

import org.springframework.stereotype.Service;
import top.ninwoo.cloud.service.FindService;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileReader;
import java.util.ArrayList;
import java.util.concurrent.ConcurrentHashMap;

@Service
public class FindServiceImpl implements FindService {
    /**
     * 根据路径表，找到本机需要处理路径条数
     * c->a ==>  sata1->sata3
     *
     * @param pathTable
     * @param currenthop
     */
    @Override
    public ArrayList<String> findDestinSataHops(String[] pathTable, String currenthop) {
        ArrayList<String>  destinSataHops = new ArrayList<String>();

        if(pathTable.length == 0){
            System.out.println("路径表为空");
            destinSataHops.add("nopara");
            return destinSataHops;
        }
        for (int i = 0; i < pathTable.length; i++) {
            //判断本机是否为路径起点
            if(currenthop.equals(pathTable[i].split("->")[0])){
                destinSataHops.add(pathTable[i].split("->")[1]);
            }
        }
        return destinSataHops;
    }

    /**
     * 根据本机卫星名，全局路由表,路由表得到本机路由表
     *
     * @param currentSataHop
     * @param routeTable
     */
    @Override
    public String[] findRoute(String currentSataHop, String[][] routeTable) {
        //判断路由表是否存在
        if (routeTable.length == 0) {
            System.out.println("路由表为空");
            return null;
        }
        //找到本机路由表
        return routeTable[0];
    }

    /**
     * 得到ip池
     */
    @Override
    public ConcurrentHashMap<String, String> findIPool() {
        ConcurrentHashMap<String, String> ipool = new ConcurrentHashMap<>();
        String str;
        // 文件地址
        File file = new File("C:\\Users\\Elf\\Desktop\\test\\sateIP.txt");
        try{
            BufferedReader br = new BufferedReader(new FileReader(file));
            while((str = br.readLine()) != null){
                ipool.put(str.split(":")[0],str.split(":")[1]);
            }
        }catch(Exception e){
            e.printStackTrace();
        }
        return ipool;
    }

    /**
     * 根据目的卫星名，本机路由表找到下一跳卫星名
     *
     * @param destinSataHop
     * @param route
     */
    @Override
    public String findNextHop(String destinSataHop, String[] route) {
        int index = Integer.parseInt(destinSataHop.split("sate")[1]);
//        return route[index-1];
        return "sate1";
    }

    @Override
    public String findIp(String sataName, ConcurrentHashMap<String,String> ipool) {
        String sataIP = ipool.get(sataName);
        if(sataIP.equals(null)){
            return "no ip";
        }
        return sataIP;
    }
}

