package top.ninwoo.edge.controller;

import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;
import top.ninwoo.api.CnfData;
import top.ninwoo.api.Picture;
import top.ninwoo.api.TacticsCtl;
import top.ninwoo.edge.service.impl.PicServiceImpl;
import top.ninwoo.edge.service.impl.TacticsImpl;
import top.ninwoo.edge.service.impl.appServiceImpl;
import top.ninwoo.edge.service.impl.transferService.DistributeServiceImpl;
import top.ninwoo.edge.service.impl.transferService.FindServiceImpl;
import top.ninwoo.edge.service.impl.transferService.TransServiceImpl;

import java.io.IOException;
import java.util.LinkedList;
import java.util.Set;

import static top.ninwoo.edge.service.impl.fileService.GetFile.*;


@Slf4j
@RestController
public class DataController {

    @Autowired
    TransServiceImpl transService;

    @Autowired
    PicServiceImpl picService;

    @Autowired
    private appServiceImpl appService;

    @Autowired
    TacticsImpl tactics;

    @Autowired
    DistributeServiceImpl distributeService;

    //发送数据包
    @RequestMapping(value = "/transfer", method = RequestMethod.POST)
    @ResponseBody
    public String Transfer(@RequestBody CnfData cnfData) throws IOException {
        System.out.println();
        log.info("//////////////////////////////////////////////");
        System.out.println();
        log.info("receive pathCompData");
        System.out.println();
        //卫星名列表
        String[] iridiums = {"IRIDIUM 103",
                "IRIDIUM 102",
                "IRIDIUM 104",
                "IRIDIUM 108",
                "IRIDIUM 113",
                "IRIDIUM 120",
                "IRIDIUM 117",
                "IRIDIUM 128",
                "IRIDIUM 133",
                "IRIDIUM 122",
                "IRIDIUM 119",
                "IRIDIUM 132",
                "IRIDIUM 139",
                "IRIDIUM 135",
                "IRIDIUM 116",
                "IRIDIUM 151",
                "IRIDIUM 137",
                "IRIDIUM 153",
                "IRIDIUM 144",
                "IRIDIUM 157" };
        //向展示效果低头
        String currentSate = iridiums[Integer.parseInt(cnfData.getCurrentSataHop().split("sate")[1])];
        log.info("currentSateHop: "+currentSate);
        System.out.println();
        String endSate = iridiums[Integer.parseInt(cnfData.getDestinSataHop().split("sate")[1])];
        log.info("endSateHop: "+endSate);
        System.out.println();

//        表示当前节点瞬时业务状态，同时将输入图片载入，及子任务名称
        /*
        * error 数据包错误
        * end 当前节点为业务处理结果接收节点
        * pathComputing 子任务所需数据准备就绪
        * wait 输入数据包不全，继续等待
        * pass 当前节点仅转发数据包
        * */
        String res = transService.parseData(cnfData);
        log.info("current task status:"+res);
        System.out.println();

        FindServiceImpl findService = new FindServiceImpl();
        switch (res) {
            //仅做转发节点
            case "pass":
//                log.info("just transfer");
//                System.out.println("just transfer");
                //装包 get0很奇怪
                CnfData newtransData = transService.packageData(cnfData).get(0);

//                log.info("nextSateHop: "+newtransData.getNextSataHop());
                String nextSate = iridiums[Integer.parseInt(cnfData.getNextSataHop().split("sate")[1])];
                log.info("nextSateHop: "+nextSate);
                System.out.println();
//                System.out.println("nextsataHop: "+newtransData.getNextSataHop());
                //发包
//                log.info("next sate ip: "+newtransData.getNextIPHop());
                log.info("nextHopIP: "+newtransData.getNextIPHop());
                System.out.println();
                transService.sendData(newtransData, newtransData.getNextIPHop());
//                log.info("transfer success！");
//                System.out.println("transfer success");
                log.info("transfer success!");
                System.out.println();
                return "transfer sucess";

            //出错
            case "error":
                System.out.println("error");
                return "error";

            //结束节点
            case "end":
                //储存图片节点
                saveToFile(cnfData.getPicture(), "/pic/out-"+cnfData.getPicture().getSliceId()+".jpg");
                String message = cnfData.getCurrentSataHop();
//                log.info("current node is the end node："+message);
                log.info("Task exec & save success");
                transService.backEarth(message);
//                System.out.println("end hop");
                return "end";

            //需要多个数据包
            case "wait":
                System.out.println("wait for more package");
                return "wait";

            //完成路径计算
            case "pathComputing":
//                System.out.println("pathComputing task process...");
                log.info("invoking picture process subTask: "+PicServiceImpl.taskName);
                System.out.println();
                //完成图像处理功能
                picService.PicTask();
                //得到图像
                LinkedList<Picture> pictures = picService.getPicPara();
                //装包
                for (CnfData newData:transService.packageData(cnfData, pictures)) {
//                    log.info("next sate name："+newData.getNextSataHop());
                    String nextSate2 = iridiums[Integer.parseInt(newData.getNextSataHop().split("sate")[1])];
                    log.info("nextSateHop: "+nextSate2);
                    System.out.println();
//                    System.out.println("nextSate: "+newData.getNextSataHop());
                    log.info("nextHopIP: "+newData.getNextIPHop());
                    System.out.println();
                    //发包
                    transService.sendData(newData, newData.getNextIPHop());
                }
//                System.out.println("cpc transfer success");

                log.info("exec"+PicServiceImpl.taskName+" & transfer success");
                System.out.println();
                return "cpc task&transfer success";

            case "distributeProcess":
                System.out.println("dbc start");
                //before 判断图片大小是否小于size
                if (distributeService.isHandle(cnfData)){
                    System.out.println("图片小于阈值，可以直接执行灰度处理");
                    return distributeService.packageHasCut(cnfData, cnfData.getPicture());
                }else {
                    //打包控制信令
                    TacticsCtl tacticsCtl = distributeService.packageTactics(cnfData);
                    //可以传输的节点数组
                    LinkedList<String> sateArr = new LinkedList<>();
                    //1.发出策略控制信令
                    //找到所有直联节点
                    Set<String> dircthops = findService.findDrictHop(cnfData.getCurrentSataHop(), tacticsCtl.getRoute());
                    System.out.println("tacticsctl sate : " + cnfData.getCurrentSataHop());
                    for (String dircthop : dircthops) {
                        System.out.println(dircthop);
                        tacticsCtl.setCurrentHop(dircthop);
                        String Ip = findService.findIp(dircthop, tacticsCtl.getIpPool());
                        String disRes = distributeService.askIsProcss(tacticsCtl, Ip);
                        if (disRes.startsWith("y")) {
                            //distributeService,加入到一个数组中，
                            sateArr.add(dircthop);
                            System.out.println("=====NEXT SATE AVILABLE: "+ dircthop);

                        }
                    }
                    if (sateArr.size() == 0) {
                        System.out.println("没有可以传输的卫星节点");
                        return "sate num not enough";
                    }
                    distributeService.setTag(true);
                    distributeService.startTranser(sateArr);
                }
                return "dbc tactics tranfer sucess";
        }
        return "i receive but i dont know what fxxking error！";
    }

    private void saveToFile(Picture picture, String s) {
    }

    @RequestMapping(value = "/askTactics", method = RequestMethod.POST)
    @ResponseBody
    public String backTactics(@RequestBody TacticsCtl tacticsCtl){
        return distributeService.backAsk(tacticsCtl);
    }


    /**
     *得到cpu计算能力模块
     */
    @GetMapping("/getOverload")
    public Float getOverload() {
        return appService.getOverload();
    }

    @GetMapping("/getCpuNum")
    public Float getCpuNum() {
        return appService.getCpuNum();
    }

    @GetMapping("/getCpuThread")
    public Float getCpuThread() {
        return appService.getCpuThread();
    }

    @GetMapping("/getCpuMhz")
    public Float getCpuMhz() {
        return appService.getCpuMhz();
    }

    @GetMapping("/getCpu")
    public String getCpu() {
        return appService.getCpu();
    }

    //得到计算能力
    //该计算能力应该在地面节点做给归一化处理
    @GetMapping("/getCpuComputing")
    public Double getCpuComputing() {
        Float overload = getOverload();
        Float cpuNum = getCpuNum();
        Float cpuThread = getCpuThread();
        Float cpuMhz = getCpuMhz();
        if(overload > 1.0){
            //System.out.println(cpuMhz*cpuNum*cpuThread*0.01);
            return cpuMhz*cpuNum*cpuThread*0.01;
        }
        //System.out.println((1-overload)*cpuMhz*cpuNum*cpuThread);
        return (double) (1-overload)*cpuMhz*cpuNum*cpuThread;
    }

    /**
     * 获取图片
     */
    @GetMapping("/getImg")
    public LinkedList<byte[]> getImg() throws IOException {
        //得到所有的图片名
        LinkedList<String> fname = getFileName();
        if ((fname != null )) {
            //得到图片的byte数组
            LinkedList<byte[]> res = getByte(fname);
            delImg(fname);
            return res;
        }
        return null;
    }

    /**
     * 测试
     */
    //发送数据包
    @RequestMapping(value = "/testrans", method = RequestMethod.POST)
    @ResponseBody
    public String testTransfer(@RequestBody CnfData cnfData){
        System.out.println("receive");
        String res = transService.parseData(cnfData);
        FindServiceImpl findService = new FindServiceImpl();
        switch (res) {
            //仅做转发节点
            case "pass":
                System.out.println("just transfer");
                //装包
                CnfData newtransData = transService.packageData(cnfData).get(0);
                //找到路由
                String[] route = findService.findRoute(cnfData.getCurrentSataHop(), cnfData.getRoute());
                //设置下一跳地址
                newtransData.setNextSataHop(findService.findNextHop(newtransData.getDestinSataHop(), route));
                //设置本机地址
                newtransData.setCurrentSataHop(newtransData.getNextSataHop());
                //设置下一跳ip地址
                String nextIP = findService.findIp(newtransData.getNextSataHop(), newtransData.getIpPool());
                newtransData.setNextIPHop(nextIP);
                //发包
                //transService.sendData(newtransData, newtransData.getNextIPHop());
                System.out.println("transfer sucess");
                return "transfer sucess";
            //出错
            case "error":
                System.out.println("error");
                return "error";
            //结束节点
            case "end":
                saveToFile(cnfData.getPicture(), "C:\\Users\\Elf\\Desktop\\test\\out.jpg");
                System.out.println("end sate");
                return "end";
            //需要多个数据包
            case "wait":
                System.out.println("wait for more package");
                return "wait";

            //任务完成,并发送
            case "sucess":
                System.out.println("task sucess");
                //完成图像处理功能
                picService.PicTask();
                //得到图像
                LinkedList<Picture> pictures = picService.getPicPara();
                //装包
                for (CnfData newData:transService.packageData(cnfData, pictures)) {
                    //发包
                    transService.sendData(newData, newData.getNextIPHop());
                    System.out.println(newData.getNextSataHop());
                    System.out.println(newData.getNextIPHop());
                }
                System.out.println("transfer sucess");
                return "task&tranfer sucess";
        }
        return "i receive but i dont know what fucking error！";
    }

    /**
     * 分散计算控制指令
     */
    @RequestMapping(value = "/tactics", method = RequestMethod.POST)
    @ResponseBody
    public String tactics(@RequestBody TacticsCtl tacticsCtl){
        //返回的是包含该信令计算能力的数据包
        TacticsCtl tacticsCtl1 = tactics.askTactics(tacticsCtl);
        if(tacticsCtl1 != null){
            //发送数据回源节点
            FindServiceImpl findService = new FindServiceImpl();

            String[] route = findService.findRoute(tacticsCtl.getCurrentHop(), tacticsCtl.getRoute());
            String backsate = findService.findNextHop(tacticsCtl.getSate(), route);
            String currentsate = tacticsCtl.getCurrentHop();
            tacticsCtl.setCurrentHop(backsate);
            System.out.println("backSate:"+backsate);
            //返回给源节点计算能力
            transService.backCtl(tacticsCtl, findService.findIp(backsate,tacticsCtl.getIpPool()));

            Set<String> dircthops = findService.findDrictHop(currentsate,tacticsCtl.getRoute());
            for (String dircthop : dircthops) {
                tacticsCtl.setCurrentHop(dircthop);
                tacticsCtl.setLevel(tacticsCtl.getLevel()+1);
                String Ip = findService.findIp(dircthop,tacticsCtl.getIpPool());
                System.out.println("sendCtl   "+dircthop+":"+Ip);
                transService.sendCtl(tacticsCtl,Ip);
            }
            return "dbc tactics tranfer sucess";
        }
        //重新打包并返回
        return null;
    }

    @RequestMapping(value = "/backtactics", method = RequestMethod.POST)
    @ResponseBody
    public String handleBack(@RequestBody TacticsCtl tacticsCtl) throws IOException {
        System.out.println("receive ctl");
        FindServiceImpl findService = new FindServiceImpl();

        String[] route = findService.findRoute(tacticsCtl.getCurrentHop(), tacticsCtl.getRoute());
        String sate = findService.findNextHop(tacticsCtl.getSate(), route);
        if(sate.equals("self")){
            //到了目的地
            String str = tactics.setTactics(tacticsCtl);
            switch (str){
                case "complete":
                    //开始处理
                    System.out.println("start dbc picture");
                    String res = tactics.handle();
                    return res;
                case "wait":
                    System.out.println("wait");
                    return "wait";
            }
        }
        //转发
        tacticsCtl.setCurrentHop(sate);
        //返回给源节点计算能力
        transService.backCtl(tacticsCtl, findService.findIp(sate,tacticsCtl.getIpPool()));
        return null;
    }
}
