package top.ninwoo.edge.service;

import java.util.ArrayList;
import java.util.Set;
import java.util.concurrent.ConcurrentHashMap;

/**
 * 发现路由
 */
public interface FindService{

    /**
     * 根据路径表，找到本机需要处理路径条数
     * c->a ==>  sata1->sata3
     */
    ArrayList<String> findDestinSataHops(String[] pathTable, String currenthop);
    /**
     * 根据本机卫星名，全局路由表,路由表得到本机路由表
     */
    String[] findRoute(String currentSataHop, String[][] routeTable);
    /**
     * 根据目的卫星名，本机路由表找到下一跳卫星名
     */
    String findNextHop(String destinSataHop, String[] route);
    /**
     * 找到本机的任务
     */
    String findTask(String currenSataHop, ConcurrentHashMap<String, String> taskMap);

    /**
     * 找到下一跳的ip地址
     * @return
     */
    String findIp(String sataName, ConcurrentHashMap<String, String> ipool);

    /**
     * 找到直联的节点
     */
    Set<String> findDrictHop(String currenthop, String[][] ipool);

    //判断是否能在第个时隙内返回
    int findBackTime(String currenthop, String dishop, String[][] route);
}
