package top.ninwoo.edge.service.impl;


import lombok.extern.slf4j.Slf4j;
import org.springframework.stereotype.Service;
import top.ninwoo.api.Picture;

import java.lang.reflect.Constructor;
import java.lang.reflect.InvocationTargetException;
import java.lang.reflect.Method;
import java.util.LinkedList;
@Slf4j
@Service
public class PicServiceImpl {

    //传入的图片
    public LinkedList<Picture> picOrigin = new LinkedList<>();
    //处理后的图片
    public LinkedList<Picture> picRes = new LinkedList<>();
    //要完成的任务
    public static String taskName;

    //需要生成 picTable（暂时不需要） 和 picPara
    //图片处理功能
    public void PicTask(){
        //清空图像
        delPicPara();
//        创建图像处理功能对象
//        log.info("prepare to invoke "+taskName);
        picRes = getPicService(taskName,1,picOrigin);       //sliceNum 参数没用到
        picOrigin.clear();
    }



    private LinkedList<Picture> getPicService(String taskName, int SliceNum, LinkedList<Picture> picOrigin) {
        String in = (taskName.substring(0, 1).toUpperCase() + taskName.substring(1)+"Impl")
                .replace("Process","Service");

        String packagePath = "top.ninwoo.edge.service.impl.picService.";
//        log.info("subtask class name:"+(packagePath+in));
        LinkedList<Picture> result = null;
        try {
            Class<?> name = Class.forName(packagePath+in);
            Constructor<?> constructor = name.getConstructor(null);
            Object instance = constructor.newInstance();
            Method picProcess = name.getMethod("picProcess", int.class, LinkedList.class);
            result = (LinkedList<Picture>) picProcess.invoke(instance,SliceNum, picOrigin);

        } catch (InstantiationException e) {
            e.printStackTrace();
        } catch (IllegalAccessException e) {
            e.printStackTrace();
        } catch (InvocationTargetException e) {
            e.printStackTrace();
        } catch (ClassNotFoundException e) {
            e.printStackTrace();
        } catch (NoSuchMethodException e) {
            e.printStackTrace();
        }
        return result;
    }

    //返回图片结果
    public LinkedList<Picture> getPicPara(){
        return picRes;
    }

    //清空图片
    public String delPicPara(){
        if(picRes.size() == 0){
            return "no para";
        }
        picRes.clear();
        return "sucess";
    }
//  装载待处理图片
    public String setPicOrigin(String task, Picture picture){
        if(picture.equals(null)){
            System.out.println("图片呢");
        }
        picOrigin.add(picture);
        taskName = task;
        //单图片情况及多图片并且全都收到
        if(picture.getSliceNum() == picOrigin.size() || !taskName.equals("mergeProcess")){
            return "success";
        }
        //多图片未完全收到
        else{
            //判断是否为同一个任务
            //初始为空
            return "wait";
            }
    }
}


//        switch (taskName){
//            case "binaryProcess":
////                创建图像处理功能对象
//                picRes = getPicService(taskName,1,picOrigin);
////                picRes = new BinaryServiceImpl().picProcess(1, picOrigin);
//                break;
//            case "cutProcess":
//                picRes = getPicService(taskName,picOrigin.get(0).getSliceNum(),picOrigin);
////                picRes = new SplitServiceImpl().picProcess(picOrigin.get(0).getSliceNum(), picOrigin);
//                break;
//            case "greyProcess":
//                picRes = getPicService(taskName,1,picOrigin);
////                picRes = new GrayServiceImpl().picProcess(1, picOrigin);
//                break;
//            case "mergeProcess":
//                picRes = getPicService(taskName,picOrigin.get(0).getSliceNum(),picOrigin);
////                picRes = new MerageServiceImpl().picProcess(picOrigin.get(0).getSliceNum(), picOrigin);
//                break;
//            case "tailorProcess":
//                picRes = getPicService(taskName,1,picOrigin);
////                picRes = new TailorServiceImpl().picProcess(1, picOrigin);
//                break;
//        }