package top.ninwoo.edge.service.impl;


import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import top.ninwoo.edge.service.appService;

@SuppressWarnings("unchecked")
@Service
public class appServiceImpl implements appService {

    @Autowired
    private LinuxUtilsImpl linuxUtils;


    @Override
    public Float getOverload() {
        String cmd = "uptime";
        String str = "error";
        String result = linuxUtils.runCmd(cmd);
        if(result.contains("Error")) {
            throw new RuntimeException(" failed!:[" + cmd + "]:" + result);
        }
        String res[] = result.split(",");
        for (String re : res) {
            if(re.startsWith("  load average")){
                str = re.split(":")[1];
            }
        }
        //以字符串形式输出
        //System.out.println(Float.parseFloat(str));
        return Float.parseFloat(str);
    }

    @Override
    public Float getCpuNum() {
        String cmd = "lscpu";
        String str = "error";
        String result = linuxUtils.runCmd(cmd);
        if(result.contains("Error")) {
            throw new RuntimeException("failed!:[" + cmd + "]:" + result);
        }
        //以字符串形式输出
        String res[] = result.split("\n");
        for (String re : res) {
            if (re.startsWith("CPU(s):")){
                str = re.split(": ")[1];
            }
        }
        //System.out.println(Float.parseFloat(str));
        return Float.parseFloat(str);
    }

    @Override
    public Float getCpuThread() {
        String cmd = "lscpu";
        String str = "error";
        String result = linuxUtils.runCmd(cmd);
        if(result.contains("Error")) {
            throw new RuntimeException("failed!:[" + cmd + "]:" + result);
        }
        //以字符串形式输出
        String res[] = result.split("\n");
        for (String re : res) {
            if (re.startsWith("Thread(s) per core:")){
                str = re.split(": ")[1];
            }
        }
        //System.out.println(Float.parseFloat(str));
        return Float.parseFloat(str);
    }

    @Override
    public Float getCpuMhz() {
        String cmd = "lscpu";
        String str = "error";
        String result = linuxUtils.runCmd(cmd);
        if(result.contains("Error")) {
            throw new RuntimeException("failed!:[" + cmd + "]:" + result);
        }
        //以字符串形式输出
        String res[] = result.split("\n");
        for (String re : res) {
            if (re.startsWith("CPU MHz:")){
                str = re.split(": ")[1];
            }
        }
        //System.out.println(Float.parseFloat(str));
        return Float.parseFloat(str);
    }

    @Override
    public String getCpu() {
        String cmd = "lscpu";
        String str = "error";
        String result = linuxUtils.runCmd(cmd);
        if(result.contains("Error")) {
            throw new RuntimeException("failed!:[" + cmd + "]:" + result);
        }
        //以字符串形式输出
        /*String res[] = result.split("\n");
        for (String re : res) {
            if (re.startsWith("CPU MHz：")){
                str = re.split("：")[1];
            }
        }*/
        //System.out.println(Float.parseFloat(str));
        return result;
    }

}