package top.ninwoo.edge.service.impl.fileService;


import top.ninwoo.api.Picture;

import java.io.*;

/**
 * save（储存）传入图片
 * load（加载）传出图片
 */

public class SaveFile {
    public static void saveToFile(Picture picture, String file_path) {
        byte[] pic_data = picture.getData();
        File targetFile = new File(file_path);
        if (targetFile.exists()) {
            targetFile.delete();
        }
        //为什么创建父类
        createParents(targetFile);
        try {
            targetFile.createNewFile();
            FileOutputStream fileOutputStream = new FileOutputStream(targetFile);
            fileOutputStream.write(pic_data);
        } catch (IOException e) {
            e.printStackTrace();
        }
    }

    public static void createParents(File f) {
        String parentName = f.getParent();
        File parent = new File(parentName);
        if (!parent.exists()) {
            createParents(parent);
            parent.mkdir();
        }
    }


    public static Picture loadPicture(String pic_url) {
        try {
            File f = new File(pic_url);
            InputStream is = new FileInputStream(f);
            byte[] b = new byte[(int) f.length()];
            is.read(b);
            is.close();
            Picture picture = new Picture();
            picture.setData(b);
            return picture;
        } catch (Exception e) {
            e.printStackTrace();
        }
        return null;
    }
}
