package top.ninwoo.edge.service.impl.transferService;


import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.ResponseEntity;
import org.springframework.stereotype.Service;
import org.springframework.web.client.RestTemplate;
import top.ninwoo.api.CnfData;
import top.ninwoo.api.Picture;
import top.ninwoo.api.TacticsCtl;
import top.ninwoo.edge.service.DistributeService;
import top.ninwoo.edge.service.impl.picService.GreyServiceImpl;

import javax.annotation.Resource;
import javax.imageio.ImageIO;
import java.awt.*;
import java.awt.image.BufferedImage;
import java.io.ByteArrayInputStream;
import java.io.ByteArrayOutputStream;
import java.io.IOException;
import java.util.LinkedList;
import java.util.concurrent.ConcurrentHashMap;

@Service
public class DistributeServiceImpl implements DistributeService {

    //是否正在做任务的标志
    //false:未开始做任务
    //true:正在做任务
    private boolean tag = false;

    private double range = 0.9;
    //切割的数值  kb
    private double size = 500;

    private CnfData oriData = new CnfData();

    private Picture oirPicture;

    private String currentSate;

    @Resource
    private RestTemplate restTemplate;

    @Autowired
    private FindServiceImpl findService;

    @Autowired
    TransServiceImpl transService;
    /**
     * 打包信令
     *
     * @param cnfData
     */
    @Override
    public TacticsCtl packageTactics(CnfData cnfData) {
        //是否需要？？？？？？
        init(cnfData);
        //打包
        TacticsCtl tacticsCtl = new TacticsCtl();
        tacticsCtl.setSate(cnfData.getOriSateHop());
        tacticsCtl.setLt(cnfData.getLt());
        tacticsCtl.setIpPool(cnfData.getIpPool());
        tacticsCtl.setRoute(cnfData.getRoute());
        return tacticsCtl;
    }

    /**
     * 发出请求，能否做任务
     * @param tacticsCtl
     * @return
     */
    @Override
    public String askIsProcss(TacticsCtl tacticsCtl, String url) {
        String IP = url + ":8083";
        ResponseEntity<String> res = restTemplate.postForEntity("http://" + IP + "/askTactics", tacticsCtl, String.class);
        if (!res.getStatusCode().is2xxSuccessful()) {
            throw new RuntimeException("send Error!");
        }
        System.out.println("send ctl sucess");
        return res.getBody();
    }

    /**
     * 返回请求
     * 若可以：y
     * 若不行：n
     */
    @Override
    public String backAsk(TacticsCtl tacticsCtl) {
        //先判断是否正在做项目
        if(tag){
            System.out.println("任务进行中");
            return "n";
        }
        //在判断是否能在三个时隙内返回
        return isback(tacticsCtl);
    }

    public void setTag(boolean tag) {
        this.tag = tag;
    }

    /**
     * 开始传输
     */
    @Override
    public String startTranser(LinkedList<String> sateArr) throws IOException {
        ConcurrentHashMap<String, Picture> picList = new ConcurrentHashMap<>();
        //1.切割图片，先给自己切割50kb
        LinkedList<byte[]> imgs = cutSelf(size, oirPicture.getData());
        Picture pic1 = new Picture();
        pic1.setData(imgs.get(0));
        pic1.setSliceId(oirPicture.getSliceId()+1);
        Picture pic2 = new Picture();
        pic2.setData(imgs.get(1));
        pic2.setSliceId(oirPicture.getSliceId()+2);
        //2.按照Set数组大小平均切割
        LinkedList<Picture> pictureLinkedList = cutAve(sateArr.size(),pic2);
        //3.放在一个hashmap中
        for (int i = 0; i < pictureLinkedList.size(); i++) {
            picList.put(sateArr.get(i),pictureLinkedList.get(i));
        }
        //4.打包成数据包发送出去
        String res = packageHasCut(oriData,pic1);
        System.out.println(res);
        
        handle(picList);
        return null;
    }

    /**
     * 判断是否小于size大小
     *
     * @param cnfData
     */
    @Override
    public boolean isHandle(CnfData cnfData) {
        if(cnfData.getPicture().getData().length / 1024.0 < size){
            return true;
        }
        return false;
    }

    /**
     * 包装要做的数据包
     */
    @Override
    public String packageHasCut(CnfData cnfData, Picture picture) {
        System.out.println("=====packageHasCut start");
        GreyServiceImpl picService = new GreyServiceImpl();
        LinkedList<Picture> pic = new LinkedList<>();
        pic.add(picture);

        LinkedList<Picture> afterpic = picService.picProcess(1,pic);

        String[] path = new String[]{cnfData.getCurrentSataHop()+"->"+cnfData.getOriSateHop()};

        cnfData.setPathTable(path);
        ConcurrentHashMap<String, String> tasktable = new ConcurrentHashMap<>();
        tasktable.put(cnfData.getOriSateHop(),"start/end");

        //任务表
        cnfData.setTaskTable(tasktable);
        //设置图片
        cnfData.setPicture(afterpic.get(0));
        cnfData.setDestinSataHop(cnfData.getOriSateHop());

        System.out.println("destinsatahop "+cnfData.getOriSateHop());

        String[] route = findService.findRoute(cnfData.getCurrentSataHop(), cnfData.getRoute());
        //设置下一跳地址
        cnfData.setNextSataHop(findService.findNextHop(cnfData.getDestinSataHop(), route));

        //设置本机地址
        cnfData.setCurrentSataHop(cnfData.getNextSataHop());
        //设置下一跳ip地址
        String nextIP = findService.findIp(cnfData.getNextSataHop(), cnfData.getIpPool());
        cnfData.setNextIPHop(nextIP);
        System.out.println("send picRes to "+nextIP);
        //发包
        transService.sendData(cnfData, cnfData.getNextIPHop());
        return cnfData.getCurrentSataHop()+" gray sucess";
    }

    /**
     * 初始化
     * @param cnfData
     */
    private void init(CnfData cnfData){
        oriData = cnfData;
        currentSate = cnfData.getCurrentSataHop();
        oirPicture = cnfData.getPicture();
    }

    //判断能否返回，并确定是第几个时隙返回
    private String isback(TacticsCtl tacticsCtl){
        //获取卫星数目
        int num = tacticsCtl.getRoute().length - 2;
        //查找是否能在三个时隙内返回
        int res = findService.findBackTime(tacticsCtl.getCurrentHop(),tacticsCtl.getSate(),tacticsCtl.getRoute());
        if (res != 0){
            return "y:" + res;
        }
        return "n";
    }

    //切割一大一小，小的50kb
    private LinkedList<byte[]> cutSelf(double size, byte[] img) throws IOException {
        LinkedList<byte[]> pictures = new LinkedList<>();
        //小于最大值，直接返回图片byte数组
        if(img.length /1024.0 <= size){
            pictures.add(img);
            return pictures;
        }
        //超过最大值，切割成两个数组，一个size的，一个是剩下的
        ByteArrayInputStream bis = new ByteArrayInputStream(img);
        BufferedImage images = ImageIO.read(bis);
        //得到高度,按长度切割，所以需要测出长度大小
        int chunkHeight = images.getHeight();
        int chunkWidth = images.getWidth();
        //二分法不断去测试得到符合要求的图片
        while(true) {
            BufferedImage newimg = new BufferedImage(chunkWidth, chunkHeight, images.getType());
            //写入图像内容
            Graphics2D gr = newimg.createGraphics();
            gr.drawImage(images, 0, 0,
                    chunkWidth, chunkHeight,
                    0, 0,
                    chunkWidth, chunkHeight,
                    null);
            gr.dispose();
            //img转化成byte数组
            byte[] byteNewImg = toByte(newimg);
            double fold = (byteNewImg.length / 1024.0) / size;
            if (fold > 1.0 || fold < range){
                chunkWidth = (int)(chunkWidth / fold);
            }else {
                BufferedImage lastimg = new BufferedImage(images.getWidth()-chunkWidth, chunkHeight, images.getType());
                //写入图像内容
                gr = lastimg.createGraphics();
                gr.drawImage(images, 0, 0,
                        images.getWidth()-chunkWidth, chunkHeight,
                        chunkWidth, 0,
                        images.getWidth(), chunkHeight,
                        null);
                gr.dispose();
                byte[] byteLastImg = toByte(lastimg);

                pictures.add(byteNewImg);
                pictures.add(byteLastImg);
                break;
            }
        }
        return pictures;
    }
    private byte[] toByte(BufferedImage newimg){
        ByteArrayOutputStream bos = new ByteArrayOutputStream();
        try {
            ImageIO.write(newimg,"jpg",bos);
        } catch (IOException e) {
            e.printStackTrace();
        }
        try {
            bos.close();
        } catch (IOException e) {
            e.printStackTrace();
        }
        return bos.toByteArray();
    }
    //平均切割
    private LinkedList<Picture> cutAve(int num, Picture picture) throws IOException {
        LinkedList<Picture> pictureLinkedList = new LinkedList<>();

        double size = (picture.getData().length/1024.0)/num*1.12;
        LinkedList<byte[]> imgs = cutSelf(size,picture.getData());

        int i = 1;
        while(true) {
            if(imgs.size() == 1){
                Picture pic = new Picture();
                pic.setSliceId(picture.getSliceId() + i);
                pic.setData(imgs.get(0));
                pictureLinkedList.add(pic);
                break;
            }
            Picture pic = new Picture();
            pic.setSliceId(picture.getSliceId() + i);
            pic.setData(imgs.get(0));
            pictureLinkedList.add(pic);

            imgs = cutSelf(size,imgs.get(1));
            i++;
        }
        return pictureLinkedList;
    }

    public String handle(ConcurrentHashMap<String, Picture> picList) throws IOException {
        for (String key : picList.keySet()) {
            CnfData cnfData = oriData;

            System.out.println(key+" : "+picList.get(key).getSliceId());

            System.out.println("currenthop: "+ currentSate);

            String[] path = new String[1];
            path[0] = currentSate +"->"+key;

            System.out.println(path[0]);

            //路径表
            cnfData.setPathTable(path);
            ConcurrentHashMap<String, String> tasktable = new ConcurrentHashMap<>();
            tasktable.put(key,"distributeProcess");
            //任务表
            cnfData.setTaskTable(tasktable);
            //设置图片
            cnfData.setPicture(picList.get(key));
            //设置目的节点
            cnfData.setDestinSataHop(key);

            System.out.println("destinsatahop "+key);

            String[] route = findService.findRoute(currentSate, cnfData.getRoute());
            //设置下一跳地址
            cnfData.setNextSataHop(findService.findNextHop(cnfData.getDestinSataHop(), route));

            //设置本机地址
            cnfData.setCurrentSataHop(cnfData.getNextSataHop());
            //设置下一跳ip地址
            String nextIP = findService.findIp(cnfData.getNextSataHop(), cnfData.getIpPool());
            cnfData.setNextIPHop(nextIP);
            System.out.println("send picRes to "+nextIP);
            //发包
            transService.sendData(cnfData, cnfData.getNextIPHop());
        }
        return "sucess";
    }
}
