package top.ninwoo.bishe.starter.service;

import top.ninwoo.bishe.starter.entity.ContainerMonitor;
import top.ninwoo.common.entity.NetworkTopology;

import java.util.List;

/**
 * 网络服务接口
 */
public interface NetworkService {
    boolean addQos(Long clusterId, String appName, String maxRate, String latency);

    /**
     * 获取逻辑网络拓扑
     * @param clusterId
     * @return
     */
    NetworkTopology getLogicalNetworkTopology(Long clusterId);

    List<String> getIpListByAppName(Long clusterId, String appName);

    String enableNetworkMonitor(Long clusterId, String appName);

    String cancelNetworkMonitor(Long clusterId, String appName);

    List<ContainerMonitor> getContainerMonitors(Long clusterId, String appName);
}
