package top.ninwoo;

import lombok.extern.slf4j.Slf4j;
import org.junit.Test;
import org.junit.runner.RunWith;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.test.context.SpringBootTest;
import org.springframework.test.context.junit4.SpringRunner;
import top.ninwoo.bishe.starter.service.ClusterService;
import top.ninwoo.bishe.starter.service.NetworkService;
import top.ninwoo.client.BisheTestMain;
import top.ninwoo.common.entity.*;

import javax.annotation.Resource;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;

@Slf4j
@RunWith(SpringRunner.class)
@SpringBootTest(classes = BisheTestMain.class)
public class StaticSateDeploy {

    @Autowired
    private ClusterService clusterService;

    @Resource
    private NetworkService networkService;

    @Test
    public void testSendSeparateConfig() {

        int sateNum = 20;

        ArrayList<SeparatedClusterConfig> clusterConfigs = new ArrayList<>();
        SeparatedClusterConfig separatedClusterConfig = new SeparatedClusterConfig();
        // TODO: 这个ID应该是从借口获取的
        separatedClusterConfig.setEdgeNodeId("192.168.253.130:18088");

        ClusterConfig clusterConfig = new ClusterConfig();
        clusterConfig.setId(11111l);
        clusterConfig.setOwner("joliu");

        List<ContainerDescription> cds = new ArrayList<>();

        for (int i = 1;i<=sateNum;i++) {
            ContainerDescription containerDescription = new ContainerDescription();
            containerDescription.setMode("normal");
            containerDescription.setReplicas(1);
            DockerContainer container = new DockerContainer();
            container.setName("sate"+i);
            container.setCommand("sh");
            container.setImage("jthu/pathcomp");
            containerDescription.setDockerContainer(container);
            cds.add(containerDescription);
        }


/*        ContainerDescription containerDescription1 = new ContainerDescription();
        containerDescription1.setMode("normal");
        containerDescription1.setReplicas(1);
        DockerContainer container1 = new DockerContainer();
        container1.setName("APP");
        container1.setCommand("sh");
        container1.setImage("jthu/pathcomp");
        containerDescription1.setDockerContainer(container1);
        cds.add(containerDescription1);*/

        clusterConfig.setDockers(cds);
        NetworkTopology topo = new NetworkTopology();
        String[] devices = new String[sateNum+1];
        for  (int i = 1;i<=sateNum;i++) {
            devices[i-1] = "sate"+i;
        }
        devices[sateNum] = "br:ovs1";
        log.info("设备列表："+Arrays.toString(devices));
        topo.setAppNames(devices);
        // 这个参数好像没啥用
        topo.setTopologyId(11);
        int[][] devicesTopo = new int[sateNum+1][sateNum+1];
        for  (int i = 0;i<=sateNum;i++) {
            for (int j = 0;j<=sateNum;j++) {
                if (i<sateNum){
                    devicesTopo[i][j] = 0;
                }else if (j!=sateNum){
                    devicesTopo[i][j] = 1;
                }else devicesTopo[i][j] = 0;
            }
        }
        log.info("网络拓扑："+ Arrays.deepToString(devicesTopo));
        topo.setTopology(devicesTopo);
//        topo.setTopology(new int[][]{{0,0,0},{0,0,0},{1,1,0}});
        clusterConfig.setTopology(topo);
        separatedClusterConfig.setClusterConfig(clusterConfig);
        clusterConfigs.add(separatedClusterConfig);

        clusterService.sendClusterConfigToEdgeNode(clusterConfigs);
    }

    @Test
    public void removeClusterFromEdgeNodeTest() {
        clusterService.removeClusterFromEdgeNode(11111L);
    }

}
